program direxist;

(*

  exits with an errorlevel of 0, if the directory given on the cmdline is found,
  otherwise exists with 1.
  (C) markus stephany, released under the terms of the GNU GPL version 2.

*)

{$IFDEF WIN32}
{$APPTYPE CONSOLE}
{$ENDIF}

uses
{$IFDEF WIN32}Windows{$ELSE}Dos{$ENDIF};

{$IFNDEF WIN32}
const
  FILE_ATTRIBUTE_DIRECTORY = Directory;
{$ENDIF}

{$I ..\LIB\VERSION.INC}

var
  a: {$IFNDEF WIN32}Word{$ELSE}Integer{$ENDIF};
  s: string;
{$IFNDEF WIN32}
  f: file;
{$ENDIF}
begin
{$I-}
  if (ParamStr(1) = '/?') or (ParamCount <> 1) then
  begin
    writeln('direxist checks the existance of the directory specified as parameter.');
    writeln('if the directory exists, errorlevel is set to 0, otherwise it''s set to 1.');
    writeln('it''s more reliable than "if exist xyz\nul" as it works on ntfs too.');
    writeln('(C) markus stephany, released under the terms of the GNU GPL.');
    writeln('direxist version: '+BT_VERSION);
    Halt(1);
  end;

  s := ParamStr(1);
  (* remove trailing backslash, except if only 2 chars and second is ':' *)
  if (Length(s) = 2) and (s[2] = ':') then
    s := s + '\'
  else if (Length(s) > 0) and (s[Length(s)] = '\') then
    Delete(s, Length(s), 1);

{$IFDEF WIN32}
  a := GetFileAttributes(PChar(s));
{$ELSE}
  Assign(F, s);
  GetFAttr(F, a);
  if (ioresult <> 0) or (DosError <> 0) then
    a := $FFFF;
{$ENDIF}
  if a = {$IFDEF WIN32} - 1{$ELSE}$FFFF{$ENDIF} then
    Halt(1)
  else if (a and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY then
    Halt(0)
  else
    Halt(1);
end.

