program msgbox;

(*

  shows a message box and returns the value of the button which has been triggered
  as the exit code.
  (C) markus stephany, released under the terms of the GNU GPL.

*)

{$APPTYPE CONSOLE}
uses
  Windows,
  Utils;

{$I ..\LIB\VERSION.INC}

var
  flags,code: cardinal;
  ext: boolean = False;
  ip: integer=1;
  msg: string;
begin
  if ParamStr(1) = '-e' then
  begin
    ext := True;
    ip := 2;
  end;

  code := 0;

  if (ParamCount = ip+1) then
    flags := MB_OK or MB_ICONINFORMATION
  else
    Val(ParamStr(ip+2), flags, code);

  if (code <> 0) or (ParamStr(ip) = '/?') or
    (ParamCount < (ip+1)) or (ParamCount > (ip+2)) then
  begin
    writeln('usage: msgbox [-e] <title> <message> [<flags>]');
    writeln;
    writeln('msgbox shows a message box (caption = <title>, message = <message>)');
    writeln('and returns the result as exit code.');
    writeln;
    writeln('if the "-e" flag is specified, some special character combinations');
    writeln('are available that will be replaced with the following values in the');
    writeln('<message> text:');
    writeln('   $M  value of <title>');
    writeln('   $_  carriage return followed by a line feed');
    writeln('   $A  ampersand &');
    writeln('   $B  pipe |');
    writeln('   $C  left parenthesis (');
    writeln('   $D  current date');
    writeln('   $E  percent sign %');
    writeln('   $F  right parenthesis )');
    writeln('   $G  greater-than sign >');
    writeln('   $H  removes the preceding character');
    writeln('   $I  single quote ''');
    writeln('   $L  less-than sign <');
    writeln('   $N  current drive');
    writeln('   $P  current path');
    writeln('   $Q  equal sign =');
    writeln('   $R  name of the remote share of the current drive (if any)');
    writeln('   $S  blank (space)');
    writeln('   $T  current time');
    writeln('   $U  current user name');
    writeln('   $W  (windows) computer name');
    writeln('   $Y  double quote "');
    writeln('   $$  dollar sign $');
    writeln('  all other characters will be written literally.');
    writeln;
    writeln('the optional <flags> value');
    writeln('is used as the uType parameter of the MessageBox api.');
    writeln('common button values:');
    writeln('    0  display a message containing an OK button (default)');
    writeln('    1  display a message containing OK and CANCEL buttons');
    writeln('    2  display a message containing ABORT, RETRY and IGNORE buttons');
    writeln('    3  display a message containing YES, NO and CANCEL buttons');
    writeln('    4  display a message containing YES and NO buttons');
    writeln;
    writeln('common kind values (added to the button value):');
    writeln('   16  display a STOP icon');
    writeln('   32  display a QUESTION MARK icon');
    writeln('   48  display an EXCLAMATION POINT icon');
    writeln('   64  display an INFORMATION icon (default)');
    writeln;
    writeln('common results:');
    writeln('    1  OK button has been clicked');
    writeln('    2  CANCEL button');
    writeln('    3  ABORT button');
    writeln('    4  RETRY button');
    writeln('    5  IGNORE button');
    writeln('    6  YES button');
    writeln('    7  NO button');
    writeln;
    writeln('(C) markus stephany, released under the terms of the GNU GPL.');
    writeln('msgbox version: '+BT_VERSION);
    Halt(1);
  end;
  msg := ParamStr(ip+1);
  if ext then
    msg := SubstituteSpecialVars(msg, PChar(ParamStr(ip)));
  Halt(MessageBox(GetForegroundWindow, PChar(msg), PChar(ParamStr(ip)), flags));
end.

